Index: proj/include/timer.h
===================================================================
--- proj/include/timer.h	(revision 194)
+++ proj/include/timer.h	(nonexistent)
@@ -1,12 +0,0 @@
-/**
- * This file concerns everything related to the timer
- */
-
-#ifndef TIMER_H_INCLUDED
-#define TIMER_H_INCLUDED
-
-int (subscribe_timer_interrupt)(uint8_t interrupt_bit, int *interrupt_id);
-
-uint32_t no_interrupts;
-
-#endif //TIMER_H_INCLUDED

Property changes on: proj/include/timer.h
___________________________________________________________________
Deleted: svn:executable
## -1 +0,0 ##
-*
\ No newline at end of property
Index: proj/include/utils.h
===================================================================
--- proj/include/utils.h	(revision 194)
+++ proj/include/utils.h	(nonexistent)
@@ -1,53 +0,0 @@
-#ifndef UTILS_H_INCLUDED
-#define UTILS_H_INCLUDED
-
-/**
- * @brief Gets the least significant byte of a 16-bit variable
- * @param val 16-bit variable
- * @param lsb Pointer to a 8-bit variable to store the value of the LSB
- * @return ERROR_CODE code representing the result of the operation, SUCCESS code is returned if everything is OK
- */
-int(util_get_LSB)(uint16_t val, uint8_t *lsb);
-
-/**
- * @brief Gets the most significant byte of a 16-bit variable
- * @param val 16-bit variable
- * @param lsb Pointer to a 8-bit variable to store the value of the MSB
- * @return ERROR_CODE code representing the result of the operation, SUCCESS code is returned if everything is OK
- */
-int(util_get_MSB)(uint16_t val, uint8_t *msb);
-
-/**
- * @brief sys_inb wrapper
- * @param port Port to read from
- * @param value Pointer to byte to store value read
- * @return ERROR_CODE code representing the result of the operation, SUCCESS code is returned if everything is OK
- */
-int (util_sys_inb)(int port, uint8_t *value);
-
-/**
- * @brief Unsubcribes Interrupts
- * @param interrupt_id Interrupt ID, value via arguments on subscription of the interrupt_id
- * @see subscribe_kbc_interrupt, subscribe_timer_interrupt
- * @return ERROR_CODE code representing the result of the operation, SUCCESS code is returned if everything is OK
- */
-int (unsubscribe_interrupt)(int *interrupt_id);
-
-/**
- * @brief Gets the minimum value out of two values.
- * @param a     First value
- * @param b     Second value
- * @return  The minimum of the two values
- */
-int32_t min(int32_t a, int32_t b);
-
-/**
- * @brief Gets the maximum value out of two values.
- * @param a     First value
- * @param b     Second value
- * @return  The maximum of the two values
- */
-int32_t max(int32_t a, int32_t b);
-
-
-#endif //UTILS_H_INCLUDED

Property changes on: proj/include/utils.h
___________________________________________________________________
Deleted: svn:executable
Index: proj/src/timer.c
===================================================================
--- proj/src/timer.c	(revision 194)
+++ proj/src/timer.c	(nonexistent)
@@ -1,18 +0,0 @@
-#include <lcom/lcf.h>
-
-#include "timer.h"
-#include "graph.h"
-#include "sprite.h"
-
-#include "i8254.h"
-
-int (subscribe_timer_interrupt)(uint8_t interrupt_bit, int *interrupt_id) {
-    if (interrupt_id == NULL) return 1;
-    *interrupt_id = interrupt_bit;
-    return (sys_irqsetpolicy(TIMER0_IRQ, IRQ_REENABLE, interrupt_id));
-}
-
-uint32_t no_interrupts = 0;
-void (timer_int_handler)() {
-    no_interrupts++;
-}

Property changes on: proj/src/timer.c
___________________________________________________________________
Deleted: svn:executable
## -1 +0,0 ##
-*
\ No newline at end of property
Index: proj/src/utils.c
===================================================================
--- proj/src/utils.c	(revision 194)
+++ proj/src/utils.c	(nonexistent)
@@ -1,35 +0,0 @@
-#include <lcom/lcf.h>
-
-#include "utils.h"
-
-#include <stdint.h>
-#include "errors.h"
-
-int(util_get_LSB)(uint16_t val, uint8_t *lsb) {
-    if (lsb == NULL) return NULL_PTR;
-    *lsb = val;
-    return SUCCESS;
-}
-
-int(util_get_MSB)(uint16_t val, uint8_t *msb) {
-    if (msb == NULL) return NULL_PTR;
-    *msb = (val >> 8);
-    return SUCCESS;
-}
-
-int (util_sys_inb)(int port, uint8_t *value) {
-    if(value == NULL) return NULL_PTR;
-    uint32_t n = 0;
-    if(sys_inb(port, &n)) return READ_ERROR;
-    *value = n;
-    return SUCCESS;
-}
-
-int (unsubscribe_interrupt)(int *interrupt_id) {
-    if (interrupt_id == NULL) return NULL_PTR;
-    if(sys_irqrmpolicy(interrupt_id)) return UNSBCR_ERROR;
-    return SUCCESS;
-}
-
-int32_t min(int32_t a, int32_t b){ return (b < a ? b : a); }
-int32_t max(int32_t a, int32_t b){ return (a < b ? b : a); }

Property changes on: proj/src/utils.c
___________________________________________________________________
Deleted: svn:executable
Index: proj/DR.mk
===================================================================
--- proj/DR.mk	(revision 194)
+++ proj/DR.mk	(revision 195)
@@ -1,10 +1,14 @@
 PROG=proj
 
 .PATH: ${.CURDIR}/src
+.PATH: ${.CURDIR}/../lab2/src
+.PATH: ${.CURDIR}/../lab3/src
+.PATH: ${.CURDIR}/../lab4/src
+.PATH: ${.CURDIR}/../lab5/src
 
 SRCS= proj.c graph.c sprite.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
 
-CPPFLAGS += -pedantic -I./include -I./bmp -I./xpm -D LCOM_MACRO -D DIOGO -D __LCOM_OPTIMIZED_
+CPPFLAGS += -pedantic -I./include -I../lab2/include -I./bmp -I./xpm -D LCOM_MACRO -D DIOGO -D __LCOM_OPTIMIZED_
 
 DPADD += ${LIBLCF}
 LDADD += -llcf
Index: proj/Makefile
===================================================================
--- proj/Makefile	(revision 194)
+++ proj/Makefile	(revision 195)
@@ -1,10 +1,14 @@
 PROG=proj
 
 .PATH: ${.CURDIR}/src
+.PATH: ${.CURDIR}/../lab2/src
+.PATH: ${.CURDIR}/../lab3/src
+.PATH: ${.CURDIR}/../lab4/src
+.PATH: ${.CURDIR}/../lab5/src
 
 SRCS= proj.c graph.c sprite.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
 
-CPPFLAGS += -pedantic -I./include -I./bmp -I./xpm -D LCOM_MACRO -D __LCOM_OPTIMIZED_
+CPPFLAGS += -pedantic -I./include -I../lab2/include -I./bmp -I./xpm -D LCOM_MACRO -D __LCOM_OPTIMIZED_
 
 DPADD += ${LIBLCF}
 LDADD += -llcf
Index: proj/TB.mk
===================================================================
--- proj/TB.mk	(revision 194)
+++ proj/TB.mk	(revision 195)
@@ -1,10 +1,14 @@
 PROG=proj
 
 .PATH: ${.CURDIR}/src
+.PATH: ${.CURDIR}/../lab2/src
+.PATH: ${.CURDIR}/../lab3/src
+.PATH: ${.CURDIR}/../lab4/src
+.PATH: ${.CURDIR}/../lab5/src
 
 SRCS= proj.c graph.c sprite.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
 
-CPPFLAGS += -pedantic -I./include -I./bmp -I./xpm -D LCOM_MACRO -D TELMO #-D __LCOM_OPTIMIZED_
+CPPFLAGS += -pedantic -I./include -I../lab2/include -I./bmp -I./xpm -D LCOM_MACRO -D TELMO #-D __LCOM_OPTIMIZED_
 
 DPADD += ${LIBLCF}
 LDADD += -llcf