Index: proj/include/ent.h
===================================================================
--- proj/include/ent.h	(revision 200)
+++ proj/include/ent.h	(revision 201)
@@ -10,20 +10,20 @@
 double (ent_get_XLength)(void);
 double (ent_get_YLength)(void);
 
-struct ent;
-typedef struct ent ent_t;
+struct gunner;
+typedef struct gunner gunner_t;
+gunner_t* (gunner_ctor)(basic_sprite_t *dude, basic_sprite_t *weapon);
+void      (gunner_dtor)(gunner_t *p);
+void (gunner_set_pos)  (gunner_t *p, int16_t x, int16_t y);
+void (gunner_set_angle)(gunner_t *p, double angle        );
+double  (gunner_get_x)       (const gunner_t *p);
+double  (gunner_get_y)       (const gunner_t *p);
+int16_t (gunner_get_x_screen)(const gunner_t *p);
+int16_t (gunner_get_y_screen)(const gunner_t *p);
+void (gunner_draw)(gunner_t *p);
 
-ent_t* (ent_ctor)(basic_sprite_t *dude, basic_sprite_t *weapon);
-void   (ent_dtor)(ent_t *p);
+struct bullet;
+typedef struct bullet bullet_t;
+bullet_t* (bullet_ctor)(basic_sprite_t *b);
 
-void (ent_set_pos)  (ent_t *p, int16_t x, int16_t y);
-void (ent_set_angle)(ent_t *p, double angle        );
-
-double  (ent_get_x)       (const ent_t *p);
-double  (ent_get_y)       (const ent_t *p);
-int16_t (ent_get_x_screen)(const ent_t *p);
-int16_t (ent_get_y_screen)(const ent_t *p);
-
-void (ent_draw)(ent_t *p);
-
 #endif //ENT_H_INCLUDED
Index: proj/include/proj_func.h
===================================================================
--- proj/include/proj_func.h	(revision 200)
+++ proj/include/proj_func.h	(revision 201)
@@ -17,7 +17,7 @@
 /**
  * @brief Updates movement variables.
  */
-void update_movement(ent_t *p);
+void update_movement(gunner_t *p);
 
 typedef struct keys {
     uint8_t w_pressed       : 1;
@@ -44,7 +44,7 @@
  * @param
  * @return Angle
  */
-double get_mouse_angle(ent_t *p);
+double get_mouse_angle(gunner_t *p);
 
 /**
  * @brief Get horizontal movement direction.
Index: proj/src/ent.c
===================================================================
--- proj/src/ent.c	(revision 200)
+++ proj/src/ent.c	(revision 201)
@@ -15,14 +15,14 @@
 double (ent_get_XLength)(void){ return graph_get_XRes()/scale; }
 double (ent_get_YLength)(void){ return graph_get_YRes()/scale; }
 
-struct ent{
+struct gunner{
     double x, y; //real position in meters
     sprite_t *dude;
     sprite_t *weapon;
 };
 
-ent_t* (ent_ctor)(basic_sprite_t *dude, basic_sprite_t *weapon){
-    ent_t *ret = malloc(sizeof(ent_t));
+gunner_t* (gunner_ctor)(basic_sprite_t *dude, basic_sprite_t *weapon){
+    gunner_t *ret = malloc(sizeof(gunner_t));
     if(ret == NULL) return NULL;
     ret->x = 0.0;
     ret->y = 0.0;
@@ -29,11 +29,11 @@
     ret->dude   = sprite_ctor(dude  );
     ret->weapon = sprite_ctor(weapon);
     if(ret->dude == NULL || ret->weapon == NULL){
-        ent_dtor(ret);
+        gunner_dtor(ret);
         return NULL;
     } else return ret;
 }
-void (ent_dtor)(ent_t *p){
+void (gunner_dtor)(gunner_t *p){
     if(p == NULL) return;
     sprite_dtor(p->dude);
     sprite_dtor(p->weapon);
@@ -40,20 +40,20 @@
     free(p);
 }
 
-void (ent_set_pos)  (ent_t *p, int16_t x, int16_t y){ p->x = x; p->y = y; }
-void (ent_set_angle)(ent_t *p, double angle        ){
+void (gunner_set_pos)  (gunner_t *p, int16_t x, int16_t y){ p->x = x; p->y = y; }
+void (gunner_set_angle)(gunner_t *p, double angle        ){
     sprite_set_angle(p->dude  , angle);
     sprite_set_angle(p->weapon, angle);
 }
 
-double  (ent_get_x)       (const ent_t *p){ return p->x; }
-double  (ent_get_y)       (const ent_t *p){ return p->y; }
-int16_t (ent_get_x_screen)(const ent_t *p){ return (p->x-x_origin)*scale; }
-int16_t (ent_get_y_screen)(const ent_t *p){ return (p->y-y_origin)*scale; }
+double  (gunner_get_x)       (const gunner_t *p){ return p->x; }
+double  (gunner_get_y)       (const gunner_t *p){ return p->y; }
+int16_t (gunner_get_x_screen)(const gunner_t *p){ return (p->x-x_origin)*scale; }
+int16_t (gunner_get_y_screen)(const gunner_t *p){ return (p->y-y_origin)*scale; }
 
-void (ent_draw)(ent_t *p){
-    const int16_t x_screen = ent_get_x_screen(p);
-    const int16_t y_screen = ent_get_y_screen(p);
+void (gunner_draw)(gunner_t *p){
+    const int16_t x_screen = gunner_get_x_screen(p);
+    const int16_t y_screen = gunner_get_y_screen(p);
     sprite_set_pos  (p->dude  , x_screen, y_screen);
     sprite_set_pos  (p->weapon, x_screen, y_screen);
     sprite_set_scale(p->dude  , scale);
Index: proj/src/proj.c
===================================================================
--- proj/src/proj.c	(revision 200)
+++ proj/src/proj.c	(revision 201)
@@ -109,16 +109,16 @@
     #ifdef TELMO
         ent_set_scale(2.0);
 
-        ent_t *shooter1 = ent_ctor(bsp_shooter, bsp_pistol); if(shooter1 == NULL) printf("Failed to get shooter1\n");
-        ent_set_pos(shooter1, 0, 0);
-        ent_set_origin(ent_get_x(shooter1)-ent_get_XLength()/2.0,
-                       ent_get_y(shooter1)-ent_get_YLength()/2.0);
+        gunner_t *shooter1 = gunner_ctor(bsp_shooter, bsp_pistol); if(shooter1 == NULL) printf("Failed to get shooter1\n");
+        gunner_set_pos(shooter1, 0, 0);
+        ent_set_origin(gunner_get_x(shooter1)-ent_get_XLength()/2.0,
+                       gunner_get_y(shooter1)-ent_get_YLength()/2.0);
 
-        ent_t *shooter2 = ent_ctor(bsp_shooter, bsp_nothing);
-        ent_set_pos(shooter2, -50, -50);
+        gunner_t *shooter2 = gunner_ctor(bsp_shooter, bsp_nothing);
+        gunner_set_pos(shooter2, -50, -50);
 
         graph_clear_screen();
-        ent_draw(shooter1);
+        gunner_draw(shooter1);
         sprite_draw(sp_crosshair);
         graph_draw();
 
@@ -152,15 +152,15 @@
                                 if (no_interrupts % refresh_count_value == 0) {
                                     update_movement(shooter1);
                                     update_scale();
-                                    ent_set_origin(ent_get_x(shooter1)-ent_get_XLength()/2.0,
-                                                   ent_get_y(shooter1)-ent_get_YLength()/2.0);
+                                    ent_set_origin(gunner_get_x(shooter1)-ent_get_XLength()/2.0,
+                                                   gunner_get_y(shooter1)-ent_get_YLength()/2.0);
 
                                     sprite_set_pos(sp_crosshair, get_mouse_X(), get_mouse_Y());
                                     double angle = get_mouse_angle(shooter1);
-                                    ent_set_angle(shooter1, angle - M_PI_2);
+                                    gunner_set_angle(shooter1, angle - M_PI_2);
                                     graph_clear_screen();
-                                    ent_draw(shooter2);
-                                    ent_draw(shooter1);
+                                    gunner_draw(shooter2);
+                                    gunner_draw(shooter1);
                                     sprite_draw(sp_crosshair);
                                     graph_draw();
                                 }
@@ -187,7 +187,7 @@
     }
 
     #ifdef TELMO
-        ent_dtor(shooter1); shooter1 = NULL;
+        gunner_dtor(shooter1); shooter1 = NULL;
     #endif
 
     basic_sprite_dtor(bsp_crosshair); bsp_crosshair = NULL;
Index: proj/src/proj_func.c
===================================================================
--- proj/src/proj_func.c	(revision 200)
+++ proj/src/proj_func.c	(revision 201)
@@ -50,9 +50,9 @@
     hor_mov = key_presses.d_pressed - key_presses.a_pressed;
 }
 
-void update_movement(ent_t *p) {
+void update_movement(gunner_t *p) {
     static const int speed = 5;
-    ent_set_pos(p, ent_get_x(p) + speed * hor_mov, ent_get_y(p) + speed * ver_mov);
+    gunner_set_pos(p, gunner_get_x(p) + speed * hor_mov, gunner_get_y(p) + speed * ver_mov);
 }
 
 void update_scale(void) {
@@ -90,8 +90,8 @@
 
 int32_t get_mouse_Y(void) { return mouse_y; }
 
-double get_mouse_angle(ent_t *p) {
-    return atan2(ent_get_y_screen(p) - mouse_y, mouse_x - ent_get_x_screen(p));
+double get_mouse_angle(gunner_t *p) {
+    return atan2(gunner_get_y_screen(p) - mouse_y, mouse_x - gunner_get_x_screen(p));
 }
 
 int get_hor_movement(void) { return hor_mov; }