Index: proj/src/sprite.c
===================================================================
--- proj/src/sprite.c	(revision 211)
+++ proj/src/sprite.c	(nonexistent)
@@ -1,7 +0,0 @@
-#include <lcom/lcf.h>
-
-#include "sprite.h"
-
-#include "graph.h"
-
-/// sprite_draw is implemented in graph.c

Property changes on: proj/src/sprite.c
___________________________________________________________________
Deleted: svn:executable
## -1 +0,0 ##
-*
\ No newline at end of property
Index: proj/include/graph_macros.h
===================================================================
--- proj/include/graph_macros.h	(revision 211)
+++ proj/include/graph_macros.h	(revision 212)
@@ -20,8 +20,9 @@
 
 // Graphics modes
 #define INDEXED_1024_768        0x105
-#define DIRECT_640_480          0x110
-#define DIRECT_800_600          0x115
+#define DIRECT_640_480_888      0x110
+#define DIRECT_800_600_888      0x115
+#define DIRECT_1024_768_888     0x118
 #define DIRECT_1280_1024_565    0x11A
 #define DIRECT_1280_1024_888    0x11B
 #define LINEAR_FRAME_BUFFER_MD  BIT(14)
Index: proj/include/proj_macros.h
===================================================================
--- proj/include/proj_macros.h	(revision 211)
+++ proj/include/proj_macros.h	(revision 212)
@@ -34,9 +34,9 @@
 #define REFRESH_RATE    60      /** @brief Screen refresh rate */
 
 //Graphics mode
-#define GRAPH_MODE      DIRECT_1280_1024_888 /** @brief Graphic mode used */
-#define MIN_SCALE       0.3                  /** @brief Minimum zoom */
-#define DEFAULT_SCALE   1.0                  /** @brief Default zoom */
-#define MAX_SCALE       10.0                 /** @brief Maximum zoom */
+#define GRAPH_MODE      DIRECT_1024_768_888 /** @brief Graphic mode used */
+#define MIN_SCALE       0.2                  /** @brief Minimum zoom */
+#define DEFAULT_SCALE   0.5                  /** @brief Default zoom */
+#define MAX_SCALE       2.0                 /** @brief Maximum zoom */
 
 #endif /* end of include guard: PROJ_MACROS_H_INCLUDED */
Index: proj/src/graph.c
===================================================================
--- proj/src/graph.c	(revision 211)
+++ proj/src/graph.c	(revision 212)
@@ -260,6 +260,8 @@
 int (graph_draw)(void){ memcpy(video_mem, video_buf, graph_get_vram_size()); return SUCCESS; }
 
 ///SPRITE
+#include "sprite.h"
+
 #include "utils.h"
 #include "fast_math.h"
 #include <math.h>
@@ -363,13 +365,13 @@
     const uint8_t *map = basic_sprite_get_map(p->bsp);
     const uint16_t bytes_pixel = graph_get_bytes_pixel();
     for(int16_t u, v, y = ymin; y < ymax; ++y){
-        unsigned pos = (xmin + y*graph_get_XRes())*bytes_pixel;
-        for(int16_t x = xmin; x < xmax; ++x, pos += bytes_pixel){
+        uint8_t *place = video_buf + (xmin + y*graph_get_XRes())*bytes_pixel;
+        for(int16_t x = xmin; x < xmax; ++x, place += bytes_pixel){
             sprite_src2pic(p, x, y, &u, &v);
             if(0 <= u && u < w && 0 <= v && v < h){
-                uint32_t c = *(uint32_t*)(map + (v*w + u)*4);
-                if(GET_ALP(c) < 0x7F)
-                    graph_set_pixel_pos(pos, c);
+                const uint8_t *c_p = map+(v*w+u)*4;
+                if(*(c_p+3) < 0x7F) //alpha
+                    memcpy(place, c_p, bytes_pixel);
             }
         }
     }
Index: proj/src/proj.c
===================================================================
--- proj/src/proj.c	(revision 211)
+++ proj/src/proj.c	(revision 212)
@@ -109,7 +109,7 @@
     #endif
 
     #ifdef TELMO
-        ent_set_scale(2.0);
+        ent_set_scale(1.0);
 
         gunner_t *shooter1 = gunner_ctor(bsp_shooter, bsp_pistol); if(shooter1 == NULL) printf("Failed to get shooter1\n");
         gunner_set_pos(shooter1, 0, 0);
Index: proj/DR.mk
===================================================================
--- proj/DR.mk	(revision 211)
+++ proj/DR.mk	(revision 212)
@@ -2,7 +2,7 @@
 
 .PATH: ${.CURDIR}/src
 
-SRCS= proj.c graph.c sprite.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
+SRCS= proj.c graph.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
 
 CPPFLAGS += -pedantic -I./include -I./bmp -I./xpm -D LCOM_MACRO -D DIOGO -D __LCOM_OPTIMIZED_
 
Index: proj/Makefile
===================================================================
--- proj/Makefile	(revision 211)
+++ proj/Makefile	(revision 212)
@@ -2,7 +2,7 @@
 
 .PATH: ${.CURDIR}/src
 
-SRCS= proj.c graph.c sprite.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
+SRCS= proj.c graph.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
 
 CPPFLAGS += -pedantic -I./include -I./bmp -I./xpm -D LCOM_MACRO -D __LCOM_OPTIMIZED_
 
Index: proj/TB.mk
===================================================================
--- proj/TB.mk	(revision 211)
+++ proj/TB.mk	(revision 212)
@@ -2,7 +2,7 @@
 
 .PATH: ${.CURDIR}/src
 
-SRCS= proj.c graph.c sprite.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
+SRCS= proj.c graph.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
 
 CPPFLAGS += -pedantic -I./include -I./bmp -I./xpm -D LCOM_MACRO -D TELMO #-D __LCOM_OPTIMIZED_
 